/* grdot1.f -- translated by f2c (version 20090411).
   You must link the resulting object file with libf2c:
	on Microsoft Windows system, link with libf2c.lib;
	on Linux or Unix systems, link with .../path/to/libf2c.a -lm
	or, if you install libf2c.a in a standard place, with -lf2c -lm
	-- in that order, at the end of the command line, as in
		cc *.o -lf2c -lm
	Source for libf2c is in /netlib/f2c/libf2c.zip, e.g.,

		http://www.netlib.org/f2c/libf2c.zip
*/

#include "pgplot.h"

/* Table of constant values */

static integer c__13 = 13;

/* *GRDOT1 -- draw dots */
/* + */
/* Subroutine */ void grdot1_(integer *points, real *x, real *y)
{
    /* System generated locals */
    integer i__1;
    static real equiv_1[2];

    /* Local variables */
    static integer i__;
#define xp (equiv_1)
#define yp (equiv_1 + 1)
    static char chr[1];
    static integer lchr, nbuf;
#define rbuf (equiv_1)

/* GRPCKG (internal routine): Draw a set of dots. */

/* Arguments: */

/* POINTS (input, integer): the number of coordinate pairs. */
/* X, Y (input, real arrays, dimensioned POINTS or greater): the */
/*       X and Y world coordinates of the points. */
/* -- */
/* 14-Mar-1997 - new routine to optimize drawing many dots [TJP]. */
/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */
/*            Include file for GRPCKG */
/* Modifications: */
/*   29-Jan-1985 - add HP2648 (KS/TJP). */
/*   16-Sep-1985 - remove tabs (TJP). */
/*   30-Dec-1985 - add PS, VPS (TJP). */
/*   27-May-1987 - remove ARGS, NULL, PS, VPS, QMS, VQMS, HIDMP, */
/*                 HP7221, GRINL (TJP). */
/*    6-Jun-1987 - remove PRTX, TRILOG, VERS, VV (TJP). */
/*   11-Jun-1987 - remove remaining built-in devices (TJP). */
/*    5-Jul-1987 - replace GRINIT, GRPLTD by GRSTAT. */
/*   16-Aug-1987 - remove obsolete variables. */
/*    9-Sep-1989 - add SAVE statement. */
/*   26-Nov-1990 - remove GRCTYP. */
/*    5-Jan-1993 - add GRADJU. */
/*    1-Sep-1994 - add GRGCAP. */
/*   21-Dec-1995 - increase GRIMAX to 8. */
/*   30-Apr-1997 - remove GRC{XY}SP */
/* ----------------------------------------------------------------------- */

/* Parameters: */
/*   GRIMAX : maximum number of concurrent devices */
/*   GRFNMX : maximum length of file names */
/*   GRCXSZ : default width of chars (pixels) */
/*   GRCYSZ : default height of chars (pixels) */


/* Common blocks: */
/*   GRCIDE : identifier of current plot */
/*   GRGTYP : device type of current plot */
/* The following are qualified by a plot id: */
/*   GRSTAT : 0 => workstation closed */
/*            1 => workstation open */
/*            2 => picture open */
/*   GRPLTD : */
/*   GRDASH : software dashing in effect? */
/*   GRUNIT : unit associated with id */
/*   GRFNLN : length of filename */
/*   GRTYPE : device type */
/*   GRXMXA : x size of plotting surface */
/*   GRYMXA : y size of plotting surface */
/*   GRXMIN : blc of plotting window */
/*   GRYMIN : ditto */
/*   GRXMAX : trc of plotting window */
/*   GRYMAX : ditto */
/*   GRSTYL : line style (integer code) */
/*   GRWIDT : line width (integer code) */
/*   GRCCOL : current color index (integer code) */
/*   GRMNCI : minimum color index on this device */
/*   GRMXCI : maximum color index on this device */
/*   GRCMRK : marker number */
/*   GRXPRE : previous (current) pen position (x) */
/*   GRYPRE : ditto (y) */
/*   GRXORG : transformation variables (GRTRAN) */
/*   GRYORG : ditto */
/*   GRXSCL : ditto */
/*   GRYSCL : ditto */
/*   GRCSCL : character scaling factor */
/*   GRCFAC : */
/*   GRCFNT : character font */
/*   GRFILE : file name (character) */
/*   GRGCAP : device capabilities (character) */
/*   GRPXPI : pixels per inch in x */
/*   GRPYPI : pixels per inch in y */
/*   GRADJU : TRUE if GRSETS (PGPAP) has been called */


/* ----------------------------------------------------------------------- */

/* Begin picture if necessary. */

    /* Parameter adjustments */
    --y;
    --x;

    /* Function Body */
    if (! grcm00_.grpltd[grcm00_.grcide - 1]) {
	grbpic_();
    }

/* Loop for points: driver support. */

    if (grcm00_.grwidt[grcm00_.grcide - 1] <= 1) {
	nbuf = 2;
	lchr = 0;
	i__1 = *points;
	for (i__ = 1; i__ <= i__1; ++i__) {
/*        -- Convert to device coordinates */
	    *xp = x[i__] * grcm00_.grxscl[grcm00_.grcide - 1] + 
		    grcm00_.grxorg[grcm00_.grcide - 1];
	    *yp = y[i__] * grcm00_.gryscl[grcm00_.grcide - 1] + 
		    grcm00_.gryorg[grcm00_.grcide - 1];
/*           -- Clip against viewport */
	    if (*xp >= grcm00_.grxmin[grcm00_.grcide - 1] && *xp <= 
		    grcm00_.grxmax[grcm00_.grcide - 1] && *yp >= 
		    grcm00_.grymin[grcm00_.grcide - 1] && *yp <= 
		    grcm00_.grymax[grcm00_.grcide - 1]) {
		grexec_(&grcm00_.grgtyp, &c__13, rbuf, &nbuf, chr, &lchr, (
			ftnlen)1);
	    }
/* L10: */
	}

/* Thick line emulation required. */

    } else {
	i__1 = *points;
	for (i__ = 1; i__ <= i__1; ++i__) {
/*        -- Convert to device coordinates */
	    *xp = x[i__] * grcm00_.grxscl[grcm00_.grcide - 1] + 
		    grcm00_.grxorg[grcm00_.grcide - 1];
	    *yp = y[i__] * grcm00_.gryscl[grcm00_.grcide - 1] + 
		    grcm00_.gryorg[grcm00_.grcide - 1];
/*           -- Clip against viewport */
	    if (*xp >= grcm00_.grxmin[grcm00_.grcide - 1] && *xp <= 
		    grcm00_.grxmax[grcm00_.grcide - 1] && *yp >= 
		    grcm00_.grymin[grcm00_.grcide - 1] && *yp <= 
		    grcm00_.grymax[grcm00_.grcide - 1]) {
		grlin3_(xp, yp, xp, yp);
	    }
/* L20: */
	}
    }

/* New pen position. */

    grcm00_.grxpre[grcm00_.grcide - 1] = *xp;
    grcm00_.grypre[grcm00_.grcide - 1] = *yp;

} /* grdot1_ */

#undef rbuf
#undef yp
#undef xp


