/* grfa.f -- translated by f2c (version 20090411).
   You must link the resulting object file with libf2c:
	on Microsoft Windows system, link with libf2c.lib;
	on Linux or Unix systems, link with .../path/to/libf2c.a -lm
	or, if you install libf2c.a in a standard place, with -lf2c -lm
	-- in that order, at the end of the command line, as in
		cc *.o -lf2c -lm
	Source for libf2c is in /netlib/f2c/libf2c.zip, e.g.,

		http://www.netlib.org/f2c/libf2c.zip
*/

#include <math.h>
#include "pgplot.h"

#define TRUE 1
#define FALSE 0

/* Table of constant values */

static integer c__20 = 20;
static integer c__1 = 1;
static integer c__3 = 3;

/* *GRFA -- fill area (polygon) */
/* + */
/* Subroutine */ void grfa_(integer *n, real *px, real *py)
{
    /* System generated locals */
    integer i__1, i__2, i__3;
    real r__1, r__2;

    /* Local variables */
    static integer i__, j;
    static real x[32], y, s1, s2, t1, t2, dy, yd;
    static integer ls, lw;
    static char chr[32];
    static integer line, lchr, nbuf;
    static real rbuf[6], temp, ymin, ymax;
    static integer nsect;
    static logical forwd;


/* GRPCKG: FILL AREA: fill a polygon with solid color.  The polygon */
/* is defined by the (x,y) world coordinates of its N vertices.  If */
/* this is not a function supported by the device, shading is */
/* accomplished by drawing horizontal lines spaced by 1 pixel.  By */
/* selecting color index 0, the interior of the polygon can be erased */
/* on devices which permit it.  The polygon need not be convex, but if */
/* it is re-entrant (i.e., edges intersect other than at the vertices), */
/* it may not be obvious which regions are "inside" the polygon.  The */
/* following rule is applied: for a given point, create a straight line */
/* starting at the point and going to infinity. If the number of */
/* intersections between the straight line and the polygon is odd, the */
/* point is within the polygon; otherwise it is outside. If the */
/* straight line passes a polygon vertex tangentially, the */
/* intersection  count is not affected. The only attribute which applies */
/* to FILL AREA is color index: line-width and line-style are ignored. */
/* There is a limitation on the complexity of the polygon: GFA will */
/* fail if any horizontal line intersects more than 32 edges of the */
/* polygon. */

/* Arguments: */

/* N (input, integer): the number of vertices of the polygon (at least */
/*       3). */
/* PX, PY (input, real arrays, dimension at least N): world coordinates */
/*       of the N vertices of the polygon. */
/* -- */
/* 16-Jul-1984 - [TJP]. */
/*  5-Aug-1986 - add GREXEC support [AFT]. */
/* 21-Feb-1987 - If needed, calls begin picture [AFT]. */
/*  7-Sep-1994 - avoid driver call for capabilities [TJP]. */
/*  1-May-1995 - fixed bug for re-entrant polygons, and optimized code */
/*               [A.F.Carman]. */
/* 18-Oct-1995 - fixed bug: emulated fill failed for reversed y-axis */
/*               [S.C.Allendorf/TJP]. */
/*  4-Dec-1995 - remove use of real variable as do-loop variable [TJP]. */
/* 20-Mar-1996 - use another do loop 40 to avoid gaps between adjacent */
/*               polygons [RS] */
/* ----------------------------------------------------------------------- */
/* ----------------------------------------------------------------------- */
/*            Include file for GRPCKG */
/* Modifications: */
/*   29-Jan-1985 - add HP2648 (KS/TJP). */
/*   16-Sep-1985 - remove tabs (TJP). */
/*   30-Dec-1985 - add PS, VPS (TJP). */
/*   27-May-1987 - remove ARGS, NULL, PS, VPS, QMS, VQMS, HIDMP, */
/*                 HP7221, GRINL (TJP). */
/*    6-Jun-1987 - remove PRTX, TRILOG, VERS, VV (TJP). */
/*   11-Jun-1987 - remove remaining built-in devices (TJP). */
/*    5-Jul-1987 - replace GRINIT, GRPLTD by GRSTAT. */
/*   16-Aug-1987 - remove obsolete variables. */
/*    9-Sep-1989 - add SAVE statement. */
/*   26-Nov-1990 - remove GRCTYP. */
/*    5-Jan-1993 - add GRADJU. */
/*    1-Sep-1994 - add GRGCAP. */
/*   21-Dec-1995 - increase GRIMAX to 8. */
/*   30-Apr-1997 - remove GRC{XY}SP */
/* ----------------------------------------------------------------------- */

/* Parameters: */
/*   GRIMAX : maximum number of concurrent devices */
/*   GRFNMX : maximum length of file names */
/*   GRCXSZ : default width of chars (pixels) */
/*   GRCYSZ : default height of chars (pixels) */


/* Common blocks: */
/*   GRCIDE : identifier of current plot */
/*   GRGTYP : device type of current plot */
/* The following are qualified by a plot id: */
/*   GRSTAT : 0 => workstation closed */
/*            1 => workstation open */
/*            2 => picture open */
/*   GRPLTD : */
/*   GRDASH : software dashing in effect? */
/*   GRUNIT : unit associated with id */
/*   GRFNLN : length of filename */
/*   GRTYPE : device type */
/*   GRXMXA : x size of plotting surface */
/*   GRYMXA : y size of plotting surface */
/*   GRXMIN : blc of plotting window */
/*   GRYMIN : ditto */
/*   GRXMAX : trc of plotting window */
/*   GRYMAX : ditto */
/*   GRSTYL : line style (integer code) */
/*   GRWIDT : line width (integer code) */
/*   GRCCOL : current color index (integer code) */
/*   GRMNCI : minimum color index on this device */
/*   GRMXCI : maximum color index on this device */
/*   GRCMRK : marker number */
/*   GRXPRE : previous (current) pen position (x) */
/*   GRYPRE : ditto (y) */
/*   GRXORG : transformation variables (GRTRAN) */
/*   GRYORG : ditto */
/*   GRXSCL : ditto */
/*   GRYSCL : ditto */
/*   GRCSCL : character scaling factor */
/*   GRCFAC : */
/*   GRCFNT : character font */
/*   GRFILE : file name (character) */
/*   GRGCAP : device capabilities (character) */
/*   GRPXPI : pixels per inch in x */
/*   GRPYPI : pixels per inch in y */
/*   GRADJU : TRUE if GRSETS (PGPAP) has been called */


/* ----------------------------------------------------------------------- */

    /* Parameter adjustments */
    --py;
    --px;

    /* Function Body */
    if (grcm00_.grcide < 1) {
	return;
    }
    if (*n < 3) {
	grwarn_("GRFA - polygon has < 3 vertices.", (ftnlen)32);
	return;
    }

/* Devices with polygon fill capability. */

    if (*(unsigned char *)&grcm01_.grgcap[(grcm00_.grcide - 1) * 11 + 3] == 
	    'A') {
	if (! grcm00_.grpltd[grcm00_.grcide - 1]) {
	    grbpic_();
	}
	rbuf[0] = (real) (*n);
	grexec_(&grcm00_.grgtyp, &c__20, rbuf, &nbuf, chr, &lchr, (ftnlen)32)
		;
	i__1 = *n;
	for (i__ = 1; i__ <= i__1; ++i__) {
	    rbuf[0] = px[i__] * grcm00_.grxscl[grcm00_.grcide - 1] + 
		    grcm00_.grxorg[grcm00_.grcide - 1];
	    rbuf[1] = py[i__] * grcm00_.gryscl[grcm00_.grcide - 1] + 
		    grcm00_.gryorg[grcm00_.grcide - 1];
	    grexec_(&grcm00_.grgtyp, &c__20, rbuf, &nbuf, chr, &lchr, (
		    ftnlen)32);
/* L10: */
	}
	return;
    }

/* For other devices fill area is simulated. */

/* Save attributes. */

    grqls_(&ls);
    grqlw_(&lw);
    grsls_(&c__1);
    grslw_(&c__1);

/* Find range of raster-lines to be shaded. */

    ymin = py[1] * grcm00_.gryscl[grcm00_.grcide - 1] + grcm00_.gryorg[
	    grcm00_.grcide - 1];
    ymax = ymin;
    i__1 = *n;
    for (i__ = 2; i__ <= i__1; ++i__) {
	yd = py[i__] * grcm00_.gryscl[grcm00_.grcide - 1] + grcm00_.gryorg[
		grcm00_.grcide - 1];
	if (yd < ymin) ymin = yd;
	if (yd > ymax) ymax = yd;
/* L20: */
    }
    grexec_(&grcm00_.grgtyp, &c__3, rbuf, &nbuf, chr, &lchr, (ftnlen)32);
    dy = fabs(rbuf[2]);

/* Find intersections of edges with current raster line. */

    forwd = TRUE;
    s1 = px[*n] * grcm00_.grxscl[grcm00_.grcide - 1] + grcm00_.grxorg[
	    grcm00_.grcide - 1];
    t1 = py[*n] * grcm00_.gryscl[grcm00_.grcide - 1] + grcm00_.gryorg[
	    grcm00_.grcide - 1];

    r__1 = ymin / dy;
    r__2 = ymax / dy;
    i__1 = (int)(r__2 + 0.5);
    for (line = (int)(r__1 + 0.5); line <= i__1; ++line) {
	y = line * dy;
	nsect = 0;
	i__2 = *n;
	for (i__ = 1; i__ <= i__2; ++i__) {
	    s2 = px[i__] * grcm00_.grxscl[grcm00_.grcide - 1] + 
		    grcm00_.grxorg[grcm00_.grcide - 1];
	    t2 = py[i__] * grcm00_.gryscl[grcm00_.grcide - 1] + 
		    grcm00_.gryorg[grcm00_.grcide - 1];
	    if ((t1 < y && y <= t2) || (t1 >= y && y > t2)) {
		++nsect;
		if (nsect > 32) {
		    grwarn_("GRFA - polygon is too complex.", (ftnlen)30);
		    return;
		}
		x[nsect - 1] = s1 + (s2 - s1) * ((y - t1) / (t2 - t1));
	    }
	    s1 = s2;
	    t1 = t2;
/* L30: */
	}

/* Sort the intersections into increasing x order. */

	i__2 = nsect;
	for (i__ = 2; i__ <= i__2; ++i__) {
	    i__3 = i__;
	    for (j = 1; j <= i__3; ++j) {
		if (x[j - 1] > x[i__ - 1]) {
		    temp = x[j - 1];
		    x[j - 1] = x[i__ - 1];
		    x[i__ - 1] = temp;
		}
/* L32: */
	    }
/* L34: */
	}

/* Draw the horizontal line-segments. */

	grcm00_.grypre[grcm00_.grcide - 1] = y;
	if (forwd) {
	    i__2 = nsect - 1;
	    for (i__ = 1; i__ <= i__2; i__ += 2) {
		grcm00_.grxpre[grcm00_.grcide - 1] = x[i__ - 1];
		grlin0_(&x[i__], &y);
/* L36: */
	    }
	    forwd = FALSE;
	} else {
	    for (i__ = nsect; i__ >= 2; i__ += -2) {
		grcm00_.grxpre[grcm00_.grcide - 1] = x[i__ - 1];
		grlin0_(&x[i__ - 2], &y);
/* L38: */
	    }
	    forwd = TRUE;
	}
/* L40: */
    }

/* Restore attributes. */

    grsls_(&ls);
    grslw_(&lw);
} /* grfa_ */

